// Chess 
// Copyright (C) 2005  Steve Driscoll (steviedisco@gmail.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA

#ifndef APPLICATION_H
#define APPLICATION_H

class CollisionManager;

class Application : public Ogre::Singleton<Application>
{
public:
	// Creation/destruction
	Application();
	virtual ~Application();

public:
	// Running application
	void run();

	SceneManager* getSceneManager();
  RenderWindow* getRenderWindow();
  CEGUI::OgreCEGUIRenderer* getGUIRenderer();
  CEGUI::System* getGUISystem();

protected:
	// Application setup
	virtual bool initialize();
	virtual void setupResources();
	virtual bool configure();
	virtual void chooseSceneManager();
	virtual void preStartRendering() = 0;

protected:
	Root *mRoot;
	RenderWindow *mWindow;
	SceneManager *mSceneManager;  
  CollisionManager *mCollisionManager;
  CEGUI::OgreCEGUIRenderer *mGUIRenderer;  
  CEGUI::System *mGUISystem;
};

#endif
