// Chess 
// Copyright (C) 2005  Steve Driscoll (steviedisco@gmail.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA

#ifndef HISTORYTABLE_H
#define HISTORYTABLE_H

class MoveListGenerator;
class Move;

class HistoryTable
{
/************************************************************************
* PUBLIC METHODS
***********************************************************************/
public:
  // Accessor
  static HistoryTable* GetInstance();  

  // Sort a list of moves, using the algorithm class as a helper
  bool SortMoveList(MoveListGenerator& theList, int movingPlayer);
  
  // History table compilation
  bool AddCount(int whichPlayer, Move& mov);
  
  // Once in a while, we must erase the history table to avoid ordering
  // moves according to the results of very old searches
  bool Forget();  

  /***********************************************************************
   * DATA MEMBERS
   **********************************************************************/

  // the table itself; a separate set of cutoff counters exists for each
  // side
  int History[2][64][64];  
  int CurrentHistory;

private:
  // This is a singleton class; the same history can be shared by two AI's
  static HistoryTable theInstance;   
};

#endif
