// Chess 
// Copyright (C) 2005  Steve Driscoll (steviedisco@gmail.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA

#ifndef INPUTMANAGER_H
#define INPUTMANAGER_H

class Piece;

class ChessInputManager : public Ogre::Singleton<ChessInputManager>
{
public:
  ChessInputManager();	
  virtual ~ChessInputManager();

  void ShowSelectionNode(SceneNode *node);
  void HideSelectionNode(void);

  void ShowCurrentNode(Ogre::Vector3 position, Piece* thePiece, int& currentPosition);
  void HideCurrentNode(void);

  void Update(Real dt);

protected:
  SceneManager *mSceneManager;    
  Entity *mSelectionEntity, *mCurrentEntity;
  SceneNode *mSelectionNode, *mCurrentNode;  
  Ogre::MovablePlane* mPlane;
};

#endif
