// Chess 
// Copyright (C) 2005  Steve Driscoll (steviedisco@gmail.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA

#ifndef PLAYER_H
#define PLAYER_H

class Board;
class Move;
class AISearchAgent;

class Player
{
public:  
  Player() : Agent(0) {};
  virtual ~Player();    

  // consts  
  static const int SIDE_WHITE = 0;  
  static const int SIDE_BLACK = 1;
  static const int TYPE_AI = 0;
  static const int TYPE_HUMAN = 1;
  static const String PlayerStrings[];

  void CreateAgent(const int whichType);
  virtual Move GetMove(Board& theBoard, bool& Continue); 

  // Accessors
  int GetSide() {return Side;}
  void SetSide(int s) {Side = s;}
  int GetType() {return Type;}
  void SetType(int t) {Type = t;}

protected:
  // The search agent in charge of the moves - should be in PlayerAI,
  // but moved to here for a cleaner destructor
  AISearchAgent* Agent;

private:
  int Side;
  int Type;  
};

#endif
