// Chess 
// Copyright (C) 2005  Steve Driscoll (steviedisco@gmail.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA

#ifndef PLAYERHUMAN_H
#define PLAYERHUMAN_H

#include "Player.h"
#include "MoveListGenerator.h"
#include "Board.h"

class Move;

class PlayerHuman : public Player
{
public:
  // Validation help
  MoveListGenerator Pseudos;
  MoveListGenerator Check;
  Board Successor;

  // Constructor
  PlayerHuman(int which) {SetSide(which); SetType(Player::TYPE_HUMAN);}
  ~PlayerHuman() {};
      
  virtual Move GetMove(Board& theBoard, bool& Continue); 
  bool CompileMove(Board* theBoard, Move* Mov);
  std::vector<int> GetValidMoves(Board& theBoard, int sourcePosition);  
};

#endif
