// Chess 
// Copyright (C) 2005  Steve Driscoll (steviedisco@gmail.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA

#ifndef STATE_H
#define STATE_H

#include <OIS.h>

using namespace OIS;

class State
{
public:
	// Creation/destruction
	State();
	virtual ~State();

public:
	// State functions
	virtual void initialize();
	virtual void cleanup();

	virtual void pause();
	virtual void resume();

	virtual void frameStarted(Real dt);
	virtual void frameEnded(Real dt);

protected:
	// State management
	void changeState(State* state);

public:
	// Key events
	virtual void keyPressed(const KeyEvent &e);
	virtual void keyReleased(const KeyEvent &e);
	virtual void keyRepeated(int kc);
protected:
	bool isKeyDown(KeyCode kc) const;

public:
	// Mouse events
	virtual void mouseMoved(const MouseEvent &e);
	virtual void mousePressed(const MouseEvent &e);
	virtual void mouseReleased(const MouseEvent &e);
};

#endif
