// Chess 
// Copyright (C) 2005  Steve Driscoll (steviedisco@gmail.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA

#ifndef TRANSPOSITIONTABLE_H
#define TRANSPOSITIONTABLE_H

#include "TranspositionEntry.h"

class Board;
class Move;

class TranspositionTable
{
/**************************************************************************
* PUBLIC METHODS
*************************************************************************/
public:  
  TranspositionTable();
  ~TranspositionTable();
  
  // Verify whether there is a stored evaluation for a given board.
  // If so, return TRUE and copy the appropriate values into the
  // output parameter
  bool LookupBoard(Board& theBoard, Move& theMove);
    
  // Store a good evaluation found through alphabeta for a certain board position
  bool StoreBoard(Board& theBoard, int eval, int evalType, int depth, int timeStamp);

/***************************************************************************
* DATA MEMBERS
**************************************************************************/
private:
  // The size of a transposition table, in entries
  static const int TABLE_SIZE = 131072;
  // Data
  TranspositionEntry Table[TABLE_SIZE];  
};

#endif
