// Chess 
// Copyright (C) 2005  Steve Driscoll (steviedisco@gmail.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA

#include "stdafx.h"
#include "ChessApplication.h"
#ifdef __unix__
#include "unixutils.h"
#endif

// Application entry point
#if OGRE_PLATFORM == OGRE_PLATFORM_WIN32
  #define WIN32_LEAN_AND_MEAN
  #define NOMINMAX
  #include <windows.h>
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
  #else
  int main(int argc, char *argv[])
#endif
{
// SIGH, ogre wants to read plugins.cfg from the current dir and in general
// read and write all kinda files from/to the currentdir, this is not how
// things are done under UNIX, this works around this ogre "feature"
#ifdef __unix__
	char *home = get_homedir();
	char buf[256];
	
	snprintf(buf, sizeof(buf), "%s/.chess", home? home:".");
	if (check_and_create_dir(buf))
		return 1;

	if (chdir(buf)) {
		perror("error creating directory ~/.chess");
		return 1;
	}
	
	unlink("media");
	if (symlink(DATADIR "media", "media")) {
		perror("error creating symlink ~/.chess/media");
		return 1;
	}
	
	unlink("plugins.cfg");
	if (symlink(DATADIR "plugins.cfg", "plugins.cfg")) {
		perror("error creating symlink ~/.chess/plugins.cfg");
		return 1;
	}
	
	unlink("resources.cfg");
	if (symlink(DATADIR "resources.cfg", "resources.cfg")) {
		perror("error creating symlink ~/.chess/resources.cfg");
		return 1;
	}
#endif	

	ChessApplication application;
	// try	{
		application.run();
	// }	catch (Ogre::Exception& e) {
  //   #if OGRE_PLATFORM == OGRE_PLATFORM_WIN32
  //      MessageBox( NULL, e.getFullDescription().c_str(), "An exception has occured!", MB_OK | MB_ICONERROR | MB_TASKMODAL);
  //   #else
  //      std::cerr << "An exception has occured: " << e.getFullDescription().c_str() << std::endl;
  //   #endif		
	// } 
	return 0;
}
