// Chess 
// Copyright (C) 2005  Steve Driscoll (steviedisco@gmail.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA

#include "stdafx.h"
#include "Collider.h"
#include "CollisionEntity.h"

bool Collider::collide(Ray* ray, CollisionEntity* entity)
{
  // get a pointer to the collision model
  CollisionModel3D* mColModel = entity->getCollisionModel();
     
  // set the world transform for the entity    
  entity->SetWorldTransform();
  
  // convert the ray  
  float Origin[3], Direction[3], colPoint[3], t1[9], t2[9];
  
  Origin[0] = ray->getOrigin().x;
  Origin[1] = ray->getOrigin().y;
  Origin[2] = ray->getOrigin().z;

  Direction[0] = ray->getDirection().x;
  Direction[1] = ray->getDirection().y;
  Direction[2] = ray->getDirection().z;  

  // check for a collision
  bool col = mColModel->rayCollision(Origin, Direction);     

  // for testing purposes
  mColModel->getCollidingTriangles(t1, t2, false);
  mColModel->getCollisionPoint(colPoint, false);

  return col;
}
