// Chess 
// Copyright (C) 2005  Steve Driscoll (steviedisco@gmail.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA

#include "stdafx.h"
#include "PlayerAI.h"
#include "Move.h"
#include "Board.h"
#include "AISearchAgentMTDF.h"

// Constructor
PlayerAI::PlayerAI(int whichPlayer, int whichType)
{
  SetSide(whichPlayer);
  SetType(Player::TYPE_AI);
  CreateAgent(whichType);
}

// Attach a search agent to the AI player
bool PlayerAI::AttachSearchAgent(AISearchAgent& theAgent)
{
  Agent = &theAgent;
  return true;
}

// Getting a move from the machine
Move PlayerAI::GetMove(Board& theBoard, bool& Continue)
{
  return((*Agent).PickBestMove(theBoard, Continue));  
}

void PlayerAI::SetDifficulty(String level)
{
  // adjust these to adjust the difficulty settings - about right I think
  if (level == "Easy")
  {
    AISearchAgentMTDF::MaxIterations = 3;
    AISearchAgentMTDF::MaxSearchSize = 15000;
  }
  else if (level == "Medium")
  {
    AISearchAgentMTDF::MaxIterations = 5;
    AISearchAgentMTDF::MaxSearchSize = 35000;
  }
  else if (level == "Hard")
  {
    AISearchAgentMTDF::MaxIterations = 15;
    AISearchAgentMTDF::MaxSearchSize = 75000;
  }
}